## ros-class-loader 2.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

project(class_loader)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CLASS_LOADER_IGNORE_AMENT FALSE CACHE BOOL
  "Do not use ament when building this package.")
if(NOT CLASS_LOADER_IGNORE_AMENT)
  find_package(ament_cmake)
  find_package(ament_cmake_ros REQUIRED)
  set(explicit_library_type "")
else()
  set(explicit_library_type "SHARED")
endif()

find_package(console_bridge_vendor REQUIRED) # Provides console_bridge 0.4.0 on platforms without it.
find_package(console_bridge REQUIRED)

find_package(rcpputils REQUIRED)

if(ament_cmake_FOUND)
  ament_export_dependencies(console_bridge)
  ament_export_dependencies(rcpputils)
endif()

add_library(${PROJECT_NAME} ${explicit_library_type}
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")

if(ament_cmake_FOUND)
  target_link_libraries(${PROJECT_NAME} PUBLIC
    console_bridge::console_bridge
    rcpputils::rcpputils)
  ament_export_targets(${PROJECT_NAME})
else()
  target_include_directories(${PROJECT_NAME}
    PUBLIC ${console_bridge_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} ${console_bridge_LIBRARIES})
endif()
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto QUIET)
  if(ament_lint_auto_FOUND)
    # TODO(mikaelarguedas) add copyright test once the linter accepts /** block comments
    list(APPEND AMENT_LINT_AUTO_EXCLUDE
      ament_cmake_copyright
    )
    ament_lint_auto_find_test_dependencies()

    # Files in test/fviz_case_study do have compatible copyrights
    find_package(ament_cmake_copyright)
    ament_copyright(
      TESTNAME copyright_check_tests_only
      "test/fviz_case_study"
    )
  endif()
  add_subdirectory(test)
endif()

if(ament_cmake_FOUND)
  ament_package(
    CONFIG_EXTRAS "class_loader-extras.cmake"
  )
else()
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${console_bridge_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/${PROJECT_NAME}.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY)

  install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc" DESTINATION lib/pkgconfig)
endif()

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY include/ DESTINATION include/${PROJECT_NAME})

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

include("../cmake/class_loader_hide_library_symbols.cmake")

# Link this 'library' to set the compile-time options requested
add_library(project_options INTERFACE)
include(../cmake/sanitizers.cmake)
enable_sanitizers(project_options)

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL SHARED plugins1.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)

add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL SHARED plugins2.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

# These plugins are loaded using dlopen() with RTLD_GLOBAL in utest and may cause side effects
# in other tests if they are used elsewhere.
add_library(${PROJECT_NAME}_TestGlobalPlugins EXCLUDE_FROM_ALL SHARED global_plugins.cpp)
target_link_libraries(${PROJECT_NAME}_TestGlobalPlugins ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestGlobalPlugins)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_utest utest.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)

if(TARGET ${PROJECT_NAME}_utest)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_utest
      PUBLIC "../include")
    target_link_libraries(${PROJECT_NAME}_utest
      console_bridge::console_bridge)
  else()
    target_include_directories(${PROJECT_NAME}_utest
      PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME}_utest)
  endif()
  target_link_libraries(${PROJECT_NAME}_utest ${PROJECT_NAME} project_options)

  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_utest pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_utest
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2
    ${PROJECT_NAME}_TestGlobalPlugins)
endif()

ament_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_unique_ptr_test)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_unique_ptr_test
      PUBLIC "../include")
  else()
    target_include_directories(${PROJECT_NAME}_unique_ptr_test
      PUBLIC "../include")
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test)
  endif()
  target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME} project_options)

  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_unique_ptr_test
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2)
endif()

add_subdirectory(fviz_case_study)

=== test/fviz_case_study/CMakeLists.txt ===
add_library(${PROJECT_NAME}_Test_Fviz EXCLUDE_FROM_ALL SHARED fviz.cpp)
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME}_Test_Fviz PRIVATE "FVIZ_BUILDING_DLL")
endif()

# This "fviz_main" is just for testing locally, for the test see "fviz_test" below.
add_executable(${PROJECT_NAME}_Test_Fviz_Main EXCLUDE_FROM_ALL fviz_main.cpp)
target_link_libraries(${PROJECT_NAME}_Test_Fviz_Main
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)

add_library(${PROJECT_NAME}_Test_FvizDefaultPlugin
  EXCLUDE_FROM_ALL SHARED fviz_default_plugin.cpp)
target_link_libraries(${PROJECT_NAME}_Test_FvizDefaultPlugin
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
class_loader_hide_library_symbols(${PROJECT_NAME}_Test_FvizDefaultPlugin)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_fviz_test fviz_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_fviz_test)
  target_link_libraries(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_fviz_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME}_Test_FvizDefaultPlugin ${PROJECT_NAME}_Test_Fviz_Main)
endif()

=== debian/changelog ===
ros-class-loader (2.9.1-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 2.9.1
  * Refresh patches (no functional changes)
  * Enable all hardening options
  * Add debian .symbols file

 -- Timo Röhling <roehling@debian.org>  Sun, 26 Oct 2025 13:32:53 +0100

=== debian/control ===
Source: ros-class-loader
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Jochen Sprickerhof <jspricke@debian.org>,
 Leopold Palomo-Avellaneda <leo@alaxarxa.net>,
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-ros,
 ament-cmake,
 ament-cmake-googletest <!nocheck>,
 ament-cmake-ros,
 ament-lint <!nocheck>,
 cmake,
 libconsole-bridge-dev,
 librcpputils-dev,
Standards-Version: 4.7.2
Section: libs
Rules-Requires-Root: no
Homepage: https://wiki.ros.org/class_loader
Vcs-Git: https://salsa.debian.org/science-team/ros-class-loader.git
Vcs-Browser: https://salsa.debian.org/science-team/ros-class-loader
Description: ROS class_loader library
 This package is part of Robot OS (ROS). The class_loader package is a
 ROS-independent package for loading plugins during runtime and the
 foundation of the higher level ROS "pluginlib" library.  class_loader
 utilizes the host operating system's runtime loader to open runtime
 libraries (e.g. .so/.dll files), introspect the library for exported
 plugin classes, and allows users to instantiate objects of said
 exported classes without the explicit declaration (i.e. header file)
 for those classes.

Package: libclass-loader-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libclass-loader3d (= ${binary:Version}),
 libconsole-bridge-dev,
 librcpputils-dev,
 ${misc:Depends},
Breaks:
 pluginlib-dev (<< 5.2.0),
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains the development files for the library.

Package: libclass-loader3d
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export ROS_CONFIGURE_ARGS = -DCLASS_LOADER_SOVERSION=3d
export ROS_EXECUTE_AFTER_CONFIGURE=sed -i -e '1icmake_policy(SET CMP0057 NEW)' -e '$$aset(class_loader_FOUND_CATKIN_PROJECT TRUE)\nset(class_loader_INCLUDE_DIRS "/usr/include/class_loader;/usr/include/rcpputils;/usr/include/rcutils")\nset(class_loader_LIBRARIES "class_loader")' obj-$(DEB_HOST_GNU_TYPE)/class_loader/ament_cmake_core/class_loaderConfig.cmake

%:
	dh $@ --buildsystem=ros

=== debian/watch ===
Version: 5

Template: Github
Owner: ros
Project: class_loader
